// Firefox specific functions for MinimizeToTray
  
if (!('extensions' in window))
    window.extensions = new Array();

if (!('mook' in window.extensions))
    window.extensions.mook = new Array();

if (!('minimizetotray' in window.extensions.mook))
    window.extensions.mook.minimizetotray = 
    function(){
        // this is a stub only
        throw Components.results.NS_ERROR_ABORT;
    };

    window.extensions.mook.minimizetotray
.trayCallback = 
function ( aEvent, aParam, aKeyMask, aMouseX, aMouseY ) {
    // note that |this| is the function itself
    var self = window.extensions.mook.minimizetotray;
    var iface = Components.interfaces.trayIWindowCallback;
    var rv = false;

    switch (aEvent) {        
        case iface.EVENT_MOUSEDBLCLK_LEFT:
            //regardless of options, if something goes bad, we
            //want to have double click default to restore.
            self.restore();
            rv = true;
            break;
        case iface.EVENT_MOUSEUP_LEFT:
            try {
 	        //if the user selected the option to only have a double
	        //click restore the window, then don't process this
                if (!self.m_prefs.getBoolPref(
                        self.k_pref_prefix + 'two-click-restore')) { 
                    self.restore();
                    rv = true;	         
                }
            }
            catch (ex) {}
            break;	
        case iface.EVENT_MOUSEUP_RIGHT:
            var popup = document.getElementById(
                self.k_xul_prefix + 'traypopup');
            self.showPopup( popup, aMouseX, aMouseY );
            rv = true;
            break;
    }
    
    return rv;
};

function openWindow(parent, url, target, features, args) {
  var wwatch = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
                         .getService(Components.interfaces.nsIWindowWatcher);

  var argstring;
  if (args) {
    argstring = Components.classes["@mozilla.org/supports-string;1"]
                            .createInstance(Components.interfaces.nsISupportsString);
    argstring.data = args;
  }
  return wwatch.openWindow(parent, url, target, features, argstring);
};

//these next few functions were copied from Mozilla code, 
//and it allows us to figure out the home page to send the browser.xul window
function chromeURL() {
    if (this.mChromeURL) {
      return this.mChromeURL;
    }
    var prefb = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);
    this.mChromeURL = prefb.getCharPref("browser.chromeURL");
    return this.mChromeURL;
};

function startPage() {
    var prefb = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    var uri = prefb.getComplexValue("browser.startup.homepage",
                                    Components.interfaces.nsIPrefLocalizedString).data;

    if (!uri) {
      prefb.clearUserPref("browser.startup.homepage");
      uri = prefb.getComplexValue("browser.startup.homepage",
                                  Components.interfaces.nsIPrefLocalizedString).data;
    }
    
    var count;
    try {
      count = prefb.getIntPref("browser.startup.homepage.count");
    }
    catch (e) {
      return uri;
    }

    for (var i = 1; i < count; ++i) {
      try {
        var page = prefb.getComplexValue("browser.startup.homepage." + i,
                                         Components.interfaces.nsIPrefLocalizedString).data;
        uri += "\n" + page;
      }
      catch (e) {
      }
    }

    return uri;
};

function startPage() {
    var prefb = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    var uri = prefb.getComplexValue("browser.startup.homepage",
                                    Components.interfaces.nsIPrefLocalizedString).data;

    if (!uri) {
      prefb.clearUserPref("browser.startup.homepage");
      uri = prefb.getComplexValue("browser.startup.homepage",
                                  Components.interfaces.nsIPrefLocalizedString).data;
    } 
    var count;
    try {
      count = prefb.getIntPref("browser.startup.homepage.count");
    }
    catch (e) {
      return uri;
    }

    for (var i = 1; i < count; ++i) {
      try {
        var page = prefb.getComplexValue("browser.startup.homepage." + i,
                                         Components.interfaces.nsIPrefLocalizedString).data;
        uri += "\n" + page;
      }
      catch (e) {
      }
    }

    return uri;
};

function defaultArgs() {
    var prefb = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefBranch);

    try {
      var choice = prefb.getIntPref("browser.startup.page");
      if (choice == 1)
        return startPage();

      if (choice == 2)
        return Components.classes["@mozilla.org/browser/global-history;2"]
                         .getService(Components.interfaces.nsIBrowserHistory).lastPageVisited;
    }
    catch (e) {
    }

    return "about:blank";
};

    window.extensions.mook.minimizetotray
.openNewBrowserWindow =	
function openNewBrowserWindow() {
    openWindow(
	    null,
        chromeURL(),
        "_blank",
        "chrome,dialog=no,all",
        defaultArgs()
        );		      
};

//trayTurboCallback fires when a user performs an action on the turbo tray icon.
//So this handles the appropriate scenarios
    window.extensions.mook.minimizetotray
.trayTurboCallback = 
function ( aEvent, aParam, aKeyMask, aMouseX, aMouseY ) {
    // callback for -turbo mode (quicklaunch)
    // note that |this| is the function itself
    var self = window.extensions.mook.minimizetotray;
    var iface = Components.interfaces.trayIWindowCallback;
    var rv = false;
    switch (aEvent) {
        case iface.EVENT_MOUSEDBLCLK_LEFT:            
            
			//launch a new browser window with the home page(s)
			window.extensions.mook.minimizetotray.openNewBrowserWindow();
            rv = true;
            break;		
	
        case iface.EVENT_MOUSEUP_RIGHT:
			//show the turbo menu
            var popup = document.getElementById(
                self.k_xul_prefix + 'trayturbopopup');
			self.showPopup( popup, aMouseX, aMouseY );
            rv = true;
            break;
    }
    return rv;
};

    window.extensions.mook.minimizetotray
.trayTurboClose = 
function () {
    var wm = 
        Components.classes["@mozilla.org/appshell/window-mediator;1"]
            .getService(Components.interfaces.nsIWindowMediator);
    var e = wm.getEnumerator(null);
    while (e.hasMoreElements()) {
        var w = e.getNext();
        if ('extensions' in w && 'mook' in w.extensions &&
          'minimizetotray' in w.extensions.mook &&
          w.extensions.mook.minimizetotray.m_isTurboMode) {
            // |w| is a turbo-mode window
            w.extensions.mook.minimizetotray.restore();
            w.close();
        }
    }
}

function initTurboMode ( ) {
    var self = window.extensions.mook.minimizetotray;

    //this works best...it only leavs about 10 pixels worth
    // of the window showing in the x-coordinate direction
    //window.moveTo(1620,1150);
    //turbo.xul should already be loaded.  Take that window 
    //and send it to the tray
    self.m_windowHider =
        Components.classes[self.k_contractid_windowHider]
            .createInstance(Components.interfaces.trayIWindowHider);
    var baseWindows = [self.getBaseWindow(window)];
    
    //window.alert(baseWindows[0]);
    self.m_windowHider.minimize(
       baseWindows.length, 
       baseWindows,
        null,
        self.trayTurboCallback); 
    
    //self.m_isTurboMode = true;
    //self.m_isHidden = true;
};

// WA: Fullscreen minimize-button Overlay
function mtt_minimizebuttonOnClick(event) {
    if(event.button==2) {
        if(event.ctrlKey) { ooh
            window.extensions.mook.minimizetotray.minimizeAll();
        } else {
            window.extensions.mook.minimizetotray.minimizeWindow();
        }
    } else if(event.button==1) {
        window.extensions.mook.minimizetotray.minimizeAll();
    }
}

function mtt_minimizebuttonOnCommand() {
    if(window.extensions.mook.minimizetotray.
       m_prefs.getBoolPref(window.extensions.mook.minimizetotray.
                           k_pref_prefix + 'always')) {
        window.extensions.mook.minimizetotray.minimizeWindow();
    } else {
        window.minimize();
    }
}



//When turbo.xul loads, load the turbo window into the tray.  
//Make sure we wait a bit first, because the load event gets called
//before the window has painted.  If we set a timeout, it waits
//for the painting to be done first before it calls initTurboMode 
window.addEventListener(    
    "load", 
    function(){window.setTimeout(initTurboMode, 100)},
    true
);             

//trying an eventlistener to catch it to load before it paints.
//window.addEventListener(    
//    "load", 
//    initTurboMode,
//    true
//);             

// signal that the app-specific parts have done loading
window.extensions.mook.minimizetotray.m_bLoadedApp = true;
